
import { Renesas } from './oa_cpu_renesas';
import { vectorType } from './oa_cpu';

export class Ra2e1 extends Renesas {
  constructor() {
    super(
      "RA2E1",
      [
        { index: 0, name: "stack", type: vectorType.value },
        { index: 10, name: "uart", type: vectorType.function },
        { index: 1, name: "boot", type: vectorType.function },
      ],
      {
        "PA0": { in: true }
      }, {
      "kotelo": {
        1: { pin: "PA1" },
        2: { pin: "PA2" },
        3: { pin: "PA3" },
      }
    });
    for (var p = 1; p < 10; p++)
      for (var i = 0; i < 15; i++) {
        this.pins[`P${p}${i.toString().padStart(2, '0')}`] = {
          in: true,
          out: true,
        }
      }
  }


  build() {
    super.build();
    //this.push_code('main.c', `oujee rene ra2e1`)
    this.push_function('init_gpio', `
    void init_gpio(int pin) {
      uint8_t dummy;
      /* xxx */
      uint8_t *ptr;
      ptr = 0x2778378;
      *ptr = 0x55 | pin;
    }
    `)
  }
}

