*** Settings ***
Documentation  Attenuator Demo
...
...            Attenuator Demo

*** Settings ***
Library         Collections
Library         rt0s_robot.py
Suite Setup     Rt0s Connect  mqtt://localhost:1000  arska  zilakka  robotti2
Suite Teardown  Rt0s Disconnect

*** Variables ***

*** Test Cases ***



Init
      Log  Starts..  WARN

      #Test Power
      Test OLED

      #Rt0s I2c Write  0  0x75  [ 4 ]  1
      #Rt0s I2c Write  0  0x75  [ 3 ]  1
      #Rt0s Attenuator Write  6
      #Rt0s Oled Clr  0  0  21
      #Rt0s Oled Write  1  0  Attenuation: 6
      #Rt0s Read One  4  0x1FFFF7AC
      #Rt0s Oled Clr  0  0  21
      #FOR  ${index}  IN RANGE  12
      #  Rt0s Oled Write  ${index}  0  ${SPACE}TADAA ${index}
      #  Sleep  1
      #END
      #Rt0s Read One  4  0x1FFFF7B0
      #Rt0s Read One  4  0x1FFFF7B4

*** Keywords ***


IIC Read Simple
      [Arguments]    ${address}  ${length}
      ${ret}=  Rt0s I2c Write  0  ${address}  [ ]  ${length}
      RETURN  ${ret}

IIC Read
      [Arguments]    ${address}  ${register}  ${length}
      ${ret}=  Rt0s I2c Write  0  ${address}  [ ${register} ]  ${length}
      RETURN  ${ret}

IIC Write
      [Arguments]    ${address}  ${register}  ${value}
      Rt0s I2c Write  0  ${address}  [ ${register}, ${value} ]  0

IIC Write Verify
      [Arguments]    ${address}  ${register}  ${value}
      IIC Write  ${address}  ${register}  ${value}
      #Rt0s I2c Write  0  ${address}  [ ${register}, ${value} ]  0

      ${ret}=  IIC Read  ${address}  ${register}  1
      #${ret}=  Rt0s I2c Write  0  ${address}  [ ${register} ]  1
      IF  ${ret} == ${value}
        Log  ${address} IIC Write ${register} OK ${value} = ${ret}  WARN
      ELSE
        Log  ${address} IIC Write ${register} FAIL ${value} != ${ret} ERROR
      END

Test Power
      IIC Write Verify  0x75  4  0x11
      FOR  ${index}  IN RANGE  20
        IIC Write Verify  0x75  1  0x1f
      END

Test OLED
      OLED Cmd   0x3c  0xb0        #page address
      OLED Cmd2  0x3c  0xda  0x02  #Set COM Pins Hardware Configuration (DAh) OK
      OLED Cmd   0x3c  0xa4        #Disable Entire Display On OK
      OLED Cmd2  0x3c  0x8d  0x14  #Enable charge pump regulator OK
      OLED Cmd  0x3c  0xaf  # disp on


OLED Clear
      [Arguments]  ${row}
      OLED Cmd2  0x3c  0  0x10
      ${reg} =  Evaluate  0xb0 + int(${row})
      OLED Cmd  0x3c  ${reg}
      OLED Data  0x3c  0xff

OLED Data
      [Arguments]  ${address}  ${value}
      ${arr}=  create list  0x40
      FOR  ${index}  IN RANGE  32
        Collections.Append To List  ${arr}  ${value}
      END
      FOR  ${index}  IN RANGE  32
        Collections.Append To List  ${arr}  0
      END
      FOR  ${index}  IN RANGE  32
        Collections.Append To List  ${arr}  ${value}
      END
      FOR  ${index}  IN RANGE  32
        Collections.Append To List  ${arr}  0
      END
      Rt0s I2c Write  0  ${address}  ${arr}  0

OLED Cmd
      [Arguments]  ${address}  ${value}
      Rt0s I2c Write  0  ${address}  [ 0 , ${value} ]  0

OLED Cmd2
      [Arguments]  ${address}  ${value}  ${value2}
      Rt0s I2c Write  0  ${address}  [ 0 , ${value}, ${value2} ]  0

Test SWD
      FOR  ${index}  IN RANGE  2
        Rt0s Swd Write  0  0  0
        Sleep  0.3
      END
