const chokidar = require('chokidar');
const fs = require('fs');

const log = console.log.bind(console);

var p: string = '/Users/arisi/dev22/oa-server/web/localhost/dynamic'
const watcher = chokidar.watch(p, {
  ignored: /(^|[\/\\])\../, // ignore dotfiles
  persistent: true
});
watcher
  .on('error', (error: any) => log(`Watcher error: ${error}`))
  .on('ready', () => log('Initial scan complete. Ready for changes'))
  .on('raw', (event: any, path: any, details: any) => { // internal
    if (details.type == 'file')
      switch (event) {
        case 'modified':
          log('MOD:', path);
          break;
        case 'created':
          log('NEW:', path);
          break;
        case 'deleted':
          log('DEL:', path);
          break;
        case 'moved':
          if (fs.existsSync(path)) {
            log('NEW:', path);
          } else
            log('DEL:', path);
          break;
        default:
          log('Raw event info:', event, path, details);
      }
    else
      log('non-file Raw event info:', event, path, details);
  });

