
var data = {}
var idc = 1;
const log = console.log.bind(console);
var objs = []
var reload_req = 0;

var requireSync = async (fn) => {
  return new Promise((res, err) => {
    require([fn], (foo) => {
      res(foo)
    });
  });
}

var stamp = () => {
  return (new Date).getTime()
}

$(document).ready(async () => {
  const urlSearchParams = new URLSearchParams(window.location.search);
  window.args = Object.fromEntries(urlSearchParams.entries());
  for (var [key,val] of Object.entries(args)) {
    if (val == 'true')
      args[key]=true
    else if (val == 'false')
      args[key] = false
    else {
      var num = parseInt(val)
      if (val == `${num}`) {
        args[key] = num;
      }
    }
  }
  var conf = JSON.parse(await Rt0s.get_file("conf.json"))
  data.conf = conf;
  for (preload of preloads) {
    var hit = preload.match(/(.+)\.(.+)$/);
    if (hit) {
      var base = hit[1]
      var ext = hit[2]
      if ((ext == 'js') && (base.substring(0, 3) == 'oa-'))
        await requireSync(base);
      else if ((ext == 'hbs') && (base.substring(0, 2) == 'p-')) {
        var key = base.substring(2);
        var ss = "";
        if (window.args.debug !== undefined && window.args.debug != 'false') {
          var debug = "";
          debug = `<div class="banner">ID:{{id}}<br>`
          debug += `{{#each req}}`
          debug += `req:{{@key}}: {{@this}}<br>`
          debug += `{{/each}}`
          debug += `{{#each args}}`
          debug += `arg:{{@key}}: {{@this}}<br>`
          debug += `{{/each}}`
          debug += `</div>`
          ss = debug + ss;
        }
        ss +=`{{#> ${key} state=state args=args}}
        ${key} Missing
        {{/${key}}}`
        log("jep", ss)
        window[`hbs_${key}`] = Handlebars.compile(ss)
        var s = await Rt0s.get_file(preload);
        Handlebars.registerPartial(key, s);
      }
    }
  }

  let observer = new MutationObserver((m) => {
    for (var o in m) {
      for (var el of m[o].addedNodes) {
        update_el(el)
      }
    }
  });

  Handlebars.registerHelper('for', function(from, to, incr, block) {
    var accum = '';
    for(var i = from; i < to; i += incr)
        accum += block.fn(i);
    return accum;
  });

  Handlebars.registerHelper('switch', function(value, options) {
    this.switch_value = value;
    return options.fn(this);
  });

  Handlebars.registerHelper('case', function(value, options) {
    if (value == this.switch_value) {
      return options.fn(this);
    }
  });

  Handlebars.registerHelper('ifEq', function(arg1, arg2, options) {
    return (arg1 == arg2) ? options.fn(this) : options.inverse(this);
  });

  Handlebars.registerHelper('hex', (dec, size) => {
    if (dec == undefined)
      return "          "
    if (size == 2)
      return sprintf("0x%02X", dec)
    else if (size == 4)
      return sprintf("0x%04X", dec)
    return sprintf("0x%08X", dec)
  })

  window.Handlebars.registerHelper('select', (value, options) => {
    var $el = $('<select />').html(options.fn(this));
    $el.find('[value="' + value + '"]').attr({ 'selected': 'selected' });
    return $el.html();
  })

  window.update_el = (el, js_reload) => {
    var cl = $(el).children()
    if (cl && cl.length) {
      for (var c of cl) {
        update_el(c,js_reload)
      }
    }
    var src = $(el).data("src")
    if (src) {
      var old_id = $(el).attr('id');
      var id
      if (old_id)
        id = old_id
      else
        id = idc++
      var req = $(el).data();
      if (req.js) {
        if (!old_id || js_reload) {
          if (js_reload && old_id) {
            var oldf = objs[id].state.fdata;
            delete objs[id]
            objs[id] = new window[`js_${req.js}`](mq, conf, id, oldf)
            objs[id].getter(req)
            objs[id].state.fdata = oldf;
          } else {
            objs[id] = new window[`js_${req.js}`](mq, conf, id)
            objs[id].getter(req)
          }
        }
      }
      try {
        $(el).html(window[src]({
          id,
          state: objs[id].state,
          req,
          args: window.args,
        }))
        $(el).attr('id', id)
        objs[id].setter() // populate the contents
      } catch (error) {
        $(el).html(`<b>ERROR: '${src}': ${error}</b>`);
      }
    }
  }

  var do_preload = (event, preload, s, initial) => {
    var hit = preload.match(/(.+)\.(.+)$/);
    if (hit) {
      var base = hit[1]
      var ext = hit[2]
      var key = `${ext}_${base}`;
      switch (event) {
        case 'modified':
          if (base == 'oaf') {
            location.reload();
            return;
          }
          if ((base.substring(0, 2) == 'p-')) {
            reload_req = stamp() + 100;
          }
        case 'created':
          switch (ext) {
            case 'css':
              $(`style[data-src='${key}']`).remove();
              $("head").append(`<style data-src="${key}">${s}</style>`);
              break;
            case 'hbs':
              if (window.args.debug !== undefined && window.args.debug != 'false') {
                var debug = "";
                debug = `<div class="banner">ID:{{id}}<br>`
                debug += `{{#each req}}`
                debug += `req:{{@key}}: {{@this}}<br>`
                debug += `{{/each}}`
                debug += `{{#each args}}`
                debug += `arg:{{@key}}: {{@this}}<br>`
                debug += `{{/each}}`
                debug += `</div>`
                s = debug + s;
              }
              window[`${key}`] = Handlebars.compile(s)
              for (var el of $(`div[data-src='${key}']`))
                update_el(el)
              break;
            case 'json':
              window[`${key}`] = JSON.parse(s)
              break;
            case 'js':
              if (base == 'oaf') return;
              if ((base.substring(0, 3) == 'oa-')) {
                if (!initial) {
                  reload_req = stamp() + 100;
                }
                return;
              }
              try {
                var ss = `window.${key} = ${s}\n`
                eval(ss)
                log("js upd",base)
                for (var el of $(`div[data-js='${base}']`)) {
                  log("hits",el)
                  update_el(el, true)
                }
              } catch (error) {
                log("js err", error)
              }
              break;
            default:
              window[`${key}`] = s
          }
          break;
        case 'deleted':
          window[`${key}`] = undefined;
      }
    }
  }

  var tick = () => {
    var now = stamp();
    if (reload_req && now > reload_req) {
      log("RELOAD")
      reload_req = 0;
      location.reload();
    }
  }
  setInterval(tick.bind(this), 50)

  var done = false
  var indi = (a,b,c) => {
    console.log("indi",a,b,c);
  }

  var butt = (a,b,c) => {
    console.log("button",a,b,c);
  }

  var ind_state = (a,b,c) => {
    console.log("ind_state",a,b,c);
  }

  var onChange = async (s) => {
    if (s && !done) {
      done = true;
      observer.observe(document.body, {
        childList: true,
        subtree: true,
        characterDataOldValue: true
      });

      $("body").append(`<div data-src="hbs_taulu" data-js="taulu">OK</div>`);

      $("body").append(`<table><tr><td data-src="hbs_lomake" data-js="lomake"></td><td data-src="hbs_lomake" data-js="lomake"></td></tr></table>`);

      $("body").append(`<div data-src="hbs_tabs" data-js="tabs">OK</div>`);
      $("body").append(`<div data-src="hbs_tabs" data-js="tabs">OK</div>`);
      $("body").append(`<div data-src="hbs_lomake" data-js="lomake">OK</div>`);
      //$("body").append(`<div data-src="hbs_uusi" data-table="xx" data-collection="yy" data-key="1212", data-js="mongo_get" >OK</div>`);

      mq.req_ind(`site_${conf.site}`, "updates", (a, status) => {
        do_preload(status.event, status.fn, status.payload)
      })
      mq.req_ind("+", 'ping', indi)
      mq.req_ind("+", 'button_state_ind', butt)
      mq.req_ind("broker", 'state', ind_state)

    }
    online = s
  }

  for (preload of preloads) {
    var s = await Rt0s.get_file(preload);
    do_preload('created', preload, s, true)
  }

  var mq = window.mq = new window.Rt0s(conf.mqtt, "weppi", conf.username, conf.password, onChange)

  for (var event of ['click', 'focusout'])
    document.addEventListener(event, (e) => {
      if (e && e.target) {
        var key = "", hit;
        for (var p of $(e.target).parents()) {
          key = $(p).data('src')
          if (key) {
            hit = p;
            break;
          }
        }
        var id = parseInt($(hit).attr('id'));
        if (objs[id]) {
          objs[id].onEvent({
            event: e.type,
            target: e.target,
            id,
            key: $(e.target).data('key'),
            data: $(e.target).data(),
          })
        }
      }
      e.preventDefault();
    });
});
