class OaTable extends OaFront {

  constructor(mq, conf, id, fdata) {
    super(id);
    this.mq = mq;
    mq.req_ind("broker", "statex", (a, status) => {
      //this.state['broker_state'] = status
      //$(`div[data-src='hbs_tadaa']`).html(window[`hbs_tadaa`](data))
      //$("input[data-name='inputti']").val("xxy")
      //console.log("obj got state", status);
    })
    this.conf = conf;
    if (fdata)
      this.state.fdata = fdata;
  }
  getter(req) {
    var rows = [
      ["aa", "bb22", "00221"],
      ["cc", "ddyx111", "00100"],
      ["cc", "ddyx111", "00102"],
    ]
    for (var i = 0; i < 49; i++)
      rows.push(["jee","juu",96000+i])
    this.state = {
      ...this.state,
      req,
      table: {
        key: "TZZZXXX",
        name: "Hieno taulu tässä",
        rows: 6,
        columns: [
          { name: "Nimii", key: 'name', type: 'string' },
          { name: "Osoite", key: 'addr', type: 'string' },
          { name: "P:nro", key: 'pno', type: 'number', size: 5 },
        ]
      },
      fdata: {
        offset: 0,
        sort: "name",
        rows,
      }
  }
    //console.log("mongo_get, req:", req, this.state);
  }

  add_row(row, pos) {
    var rlen=row.length
    var cols=this.state.table.columns.length
    if (rlen != cols) {
      for (var i = rlen; i < cols;i++)
        row.push('')
    }
    if (pos) {
      this.state.fdata.rows.splice(pos, 0, row)
    } else
      this.state.fdata.rows.push(row)
    this.setter()
  }

  del_row(pos) {
    if (pos>=0) {
      this.state.fdata.rows.splice(pos, 1)
      this.setter()
    }
  }

  add_column(col, pos) {
    if (pos) {
      this.state.table.columns.splice(pos, 0, col)
      for (var r in this.state.fdata.rows)
        this.state.fdata.rows[r].splice(pos,0,'')
    } else {
      this.state.table.columns.push(col)
      for (var r in this.state.fdata.rows)
        this.state.fdata.rows[r].push('')
    }
    this.render()
  }

  del_column(pos) {
    if (pos) {
      this.state.table.columns.splice(pos, 1)
      for (var r in this.state.fdata.rows)
        this.state.fdata.rows[r].splice(pos,1)
    }
    this.render()
  }

  set_rows(i,offset) {
    if (i) {
      this.state.table.rows = i;
      this.state.fdata.offset = offset;
      this.render()
    }
  }

  sort(key) {
    var hit = this.state.table.columns.findIndex(c => c.key == key);
    console.log("zzort",key, hit);
    if (hit != -1) {
      if (this.state.fdata.sort != key) {
        this.state.fdata.sort = key;
        this.state.fdata.sort_index = hit;
        this.state.fdata.offset = 0;
        this.setter()
      }
    }
  }

  setter() {
    console.log("taulu setteri", this.state);
    for (var col of this.state.table.columns) {
      var col_key = `[data-sort_key='${col.key}']`;
      if (col.key == this.state.fdata.sort) {
        $(`#${this.id}`).find(col_key).addClass('active');
      } else
        $(`#${this.id}`).find(col_key).removeClass('active');
    }
    var sorted = this.state.fdata.rows.sort((a, b) => {
      if (String(a[this.state.fdata.sort_index]) < String(b[this.state.fdata.sort_index]))
        return -1;
      if (String(a[this.state.fdata.sort_index]) > String(b[this.state.fdata.sort_index]))
        return 1;
      return 0;
    })
    for (var row = 0; row < this.state.table.rows; row++) {
      for (var fld_index in this.state.table.columns) {
        var fld = this.state.table.columns[fld_index]
        var id = `#${this.state.table.key}_${fld.key}_${row}`;
        var el = $(id)
        if (el) {
          var r = row + this.state.fdata.offset
          var rr = sorted[r]
          if (rr && rr[fld_index])
            el.html(rr[fld_index])
          else
            el.html("&nbsp;")
        }
      }
    }
    $(`#${this.id}`).find("[data-id='pos']")[0].innerHTML =
      `Showing ${this.state.fdata.offset + 1} to ${this.state.fdata.offset + 1 + this.state.table.rows} of ${this.state.fdata.rows.length}`
    var s = "", cpage = this.state.fdata.offset / this.state.table.rows;
    for (var i = -2; i <= 2; i++) {
      var p = cpage + i;
      if (p >= 0 && p <=Math.floor(this.state.fdata.rows.length/this.state.table.rows)) {
        if (p == cpage)
          s += `&nbsp;${p + 1}&nbsp;`
        else
          s += `<button data-act="page" data-page=${p*this.state.table.rows}>${p + 1}</button>`;
      }
    }
    $(`#${this.id}`).find("[data-id='buttos']")[0].innerHTML = s;
  }
  onEvent(obj) {
    switch (obj.event) {
      case 'click':
        log("taulun solu klikki", obj.data, this.id, this.state.req, this.state.fdata, obj.target.id)
        switch (obj.data.act) {
          case 'sort':
            this.sort(obj.data.sort_key)
            break;
          case 'start':
            this.state.fdata.offset = 0;
            this.setter()
            break;
          case 'end':
            this.state.fdata.offset = this.state.table.rows*Math.floor(this.state.fdata.rows.length/this.state.table.rows);
            this.setter()
            break;
          case 'right':
            if (this.state.fdata.offset +this.state.table.rows< this.state.fdata.rows.length) {
              this.state.fdata.offset += this.state.table.rows;
              this.setter()
            }
            break;
          case 'left':
            if (this.state.fdata.offset >0) {
              this.state.fdata.offset -= this.state.table.rows;
              if (this.state.fdata.offset < 0)
                this.state.fdata.offset = 0;
              this.setter()
            }
            break;
          case 'page':
              this.state.fdata.offset = obj.data.page;
              this.setter()
            break;
          default:
            console.log("act", obj.data.act);
            break;
        }
      break;
    }
  }
}
